from tkinter import *
import random, time
#--------------(共通関数)-------------
def array(N1, N2=0,N3=0,init=0):   #■配列宣言
    if N2==0: return [init for i in range(N1)]
    if N3==0: return [[init for i in range(N2)]
                      for j in range(N1)]
    return[[[init for i in range(N3)]for j in range(N2)]
           for k in range(N1)]
def initData(canvas, numX,numY):
    ID=array(numX,numY); DD=400/numX
    for x in range(numX):
        X=x*DD+20
        for y in range(numY):
            Y=y*DD+20; R=random.random()
            if   R<0.15:CL="#FF0000"
            elif R<0.30:CL="#00FF00"
            elif R<0.45:CL="#0000FF"
            else:CL="#000000"
            ID[x][y]=canvas.create_rectangle(X,Y,X+DD,Y+DD,
                                             fill=CL,outline="#FFFFFF")
    return ID
def getDT(canvas,ID):#■データ取り出し
    numX=len(ID);numY=len(ID[0])        # 添字判定を少なくするため
    DTab=array(numX+2,numY+2,init="#000000")# 周りにFalseを詰め
    for x in range(numX):               # 配列位置を1だけずらす
        for y in range(numY):
            CL=canvas.itemcget(ID[x][y], option="fill");k=0
            DTab[x+1][y+1]=CL
    return DTab

def sepRGB(C):
    R=C[1]+C[2]; G=C[3]+C[4];B=C[5]+C[6]
    return [int(R,16),int(G,16),int(B,16)]
#def setHex2(D):
#    return "%02X" %D
def newColor(DTab,ii,jj):
    R=0;G=0;B=0;Count=3
    for k1 in range(-1,2):# 周りの生物カウント
        for k2 in range(-1,2):
            LL=sepRGB(DTab[ii+k1][jj+k2])
            R+=LL[0];G+=LL[1];B+=LL[2]
    R=int(R/Count+0.5);G=int(G/Count+0.5);B=int(B/Count+0.5)
    return "#%02X%02X%02X" % (R,G,B)
def newColor2(DTab,ii,jj):
    CL=array(9);ip=0
    for k1 in range(-1,2):# 周りの生物カウント
        for k2 in range(-1,2):
            if DTab[ii+k1][jj+k2]!="#000000":
                CL[ip]=DTab[ii+k1][jj+k2];ip+=1
    return CL[int(ip*random.random())]
def execLG(canvas,ID,numX,numY):#■ライフ・ゲームの実行
    DTab=getDT(canvas,ID)
    for jj in range(1,numX+1):
        for ii in range(1,numY+1):
            Count=0
            for k1 in range(-1,2):# 周りの生物カウント
                for k2 in range(-1,2):
                    if k1!=0 or k2!=0:# 該当セル以外のみカウント
                        if DTab[ii+k1][jj+k2]!="#000000": Count += 1
            if DTab[ii][jj]!="#000000":
                if Count!=2 and Count!= 3:#個数2,3でないとき死ぬ
                    canvas.itemconfig(ID[ii-1][jj-1], fill="#000000")
            elif Count==3:#個数3のとき産まれる
                CL=newColor(DTab,ii,jj)
                canvas.itemconfig(ID[ii-1][jj-1], fill=CL)
def Lbutton(event):
    global exeFlag,root,canvas,ID,numX,numY
    exeFlag=False
    root.update();time.sleep(0.1)
    execLG(canvas,ID,numX,numY)
    
root=Tk();root.title("Colorful Life Game")
canvas=Canvas(root,width=440,height=440,bg="white")
canvas.pack();root.update()
exeFlag=True; canvas.bind("<1>",Lbutton)
numX=20;numY=20; ID=initData(canvas,numX,numY)
while exeFlag:
    root.update();time.sleep(0.1)
    execLG(canvas,ID,numX,numY)
mainloop()
    



